/* $Id: CalcFFT.java,v 1.4 2007/12/27 09:59:07 mit Exp $ */
/* CalcFFT.java */

public class CalcFFT {
    private int NN, N2;
    private double[] Gau;
    private double[] Re;
    private double[] Im;
    private FFT fftN;

    private static double[] YY;

    public CalcFFT() {}
    public void initFFT(int nn) {
	NN = nn;
	N2 = NN/2;
	fftN = new FFT(NN);
	YY = new double[N2];
	initGauss();
    } 
    public static double[] getData() {
	return YY;
    }
    public static double getData(int num) {
	return YY[num];
    }
    //---

    public void initGauss() {
        Gau = new double[NN];
        double in, rn = 1.0/NN;
        for (int i = 0; i < NN; i++) {
            in = (2.0*i-NN)*rn;
            Gau[i] = Math.exp(-4.5*in*in);
        }
    }
    public void gauss(int[] ad) {
        for (int i = 0; i < NN; i++) {
            Re[i] = ad[i]*Gau[i];
            Im[i] = 0;
        }
    }
    public void fft(int[] n) {
        Re = new double[NN];
        Im = new double[NN];
        gauss(n);
        fftN.fft(Re, Im);
        for (int i = 0; i < N2; i++)
            YY[i] = Math.sqrt(Re[i]*Re[i]+Im[i]*Im[i]);
    }
}