/* $Id: CalcFilter.java,v 1.3 2010/12/04 00:02:26 mit Exp $
/* CalcFilter.java v0.0 */

public class CalcFilter{
    private int NN, N2;
    private double LPS1;
    private double MaxData;
    private double[] Data;
    private double[] Wind;
    private double[] Re;
    private double[] Im;
    private FFT fftN;

    static final double P2 = Math.PI*2;

    public CalcFilter() {}
    public void initFilter(int nn) {
        NN = nn;
        N2 = NN/2;
	LPS1 = 1.0/(NN-1);

        fftN = new FFT(NN);
        Wind = new double[NN];
        Re = new double[NN];
        Im = new double[NN];

        initHanning();
    }
    //
    public void calcFilter(int[] wave, int ff, int bb) {
	int len = wave.length;
	Data = new double[len];
	int[] wav = new int[NN];
        int cnt = 0;
        int devid = (len-N2)/N2+1;         // NN1/2ե()
        int f1 = ff-bb, f2 = ff+bb;
	MaxData = 0;

        BreakOut:
        for (int j = 0; j < devid; j++) {
            cnt = N2*j;                    // NNȾʬ
            for (int i = 0; i < NN; i++) {
                if (cnt+i >= len)          // ǡʤdevidλ
                    break BreakOut;
                wav[i] = wave[cnt+i];
            }
            hanning(wav);
            fftN.fft(Re, Im);              // fftԤ

            for (int i = 0; i < NN; i++) { // ϰϳ0
                if (f1 > i || f2 < i)
                    Im[i] = Re[i] = 0;
            }
            fftN.ifft(Re, Im);             // fftԤ
            for (int i = 0; i < NN; i++) { // եȤǹ
                Data[cnt+i] += Re[i];      // realʬ
		MaxData = Math.max(MaxData, Data[cnt+i]);
	    }
	}
    }
    public double[] getData() {
	return Data;
    }
    public double getData(int num) {
	return Data[num];
    }
    public double getMaxData() {
	return MaxData;
    }
    //
    public void initHanning() {
	for (int i = 0; i < NN; i++)
	    Wind[i]= 0.5-0.5*Math.cos(P2*i*LPS1);
    }
    public void initHamming() {
	for (int i = 0; i < NN; i++)
	    Wind[i] = 0.54-0.46*Math.cos(P2*i*LPS1);
    }
    public void hanning(int[] ad) {
        for (int i = 0; i < NN; i++)
            Re[i] = Im[i] = ad[i]*Wind[i];
    }
    public void hamming(int[] ad) {
        for (int i = 0; i < NN; i++)
            Re[i] = Im[i] = ad[i]*Wind[i];
    }
}