/* $Id: Complex.java,v 1.1 2007/12/20 09:04:42 mit Exp $ */
/* Complex.java v0.2 */

public class Complex {
    public double real;
    public double imag;

    public Complex() {
	real = 0.0;
	imag = 0.0;
    }
    public Complex(double re) {
	real = re;
	imag = 0.0;
    }
    public Complex(double re, double im) {
	real = re;
	imag = im;
    }
    //
    public double re() {
	return real;
    }
    public double im() {
	return imag;
    }
    public Complex createPolar(double re, double theta) {
	return new Complex(re*Math.cos(theta), re*Math.sin(theta));
    }
    public Complex add(Complex adder) {
	return new Complex(real+adder.real, imag+adder.imag);
    }
    public Complex substract(Complex sub) {
	return new Complex(real-sub.real, imag-sub.imag);
    }
    public Complex multiply(double a) {
	return new Complex(real*a, imag*a);
    }
    public Complex multiply(Complex mul) {
	return new Complex(real*mul.real-imag*mul.imag,
			   real*mul.imag+imag*mul.real);
    }
    public Complex divide(Complex div) {
	return new Complex((real*div.real+imag*div.imag)/div.square(),
			   (imag*div.real-real*div.imag)/div.square());
    }
    public Complex exponent() {
	double ex = Math.exp(real);

	return new Complex(ex*Math.cos(imag), ex*Math.sin(imag));
    }
    public double magnitude() {
	return Math.sqrt(real*real+imag*imag);
    }
    public double square() {
	return real*real+imag*imag;
    }
    public String toString() {
	StringBuffer sb = new StringBuffer().append(real);

	return sb.append("+").append(imag).append('i').toString();
    }
}