/* $Id: FWT.java,v 1.3 2008/01/11 10:32:17 mit Exp $ */
/* FWT.java v0.2 */

public class FWT {
    private final double[] wave = {
	0.11154074335011, 0.49462389039845, 
	0.75113390802110, 0.31525035170920,
	-0.22626469396544, -0.12976686756727,
	0.09750160558732, 0.02752286553031,
	-0.03158203931749, 0.00055384220116,
	0.00477725751095, -0.00107730108531}; // DaubechiesN6

    private int Len;
    private double[] P;
    private double[] Q;
    private double[] S1;
    private double[] W1;
    private static double[] Scl;

    public FWT() {
	setFWT();
    }
    public void setFWT() {
	Len = wave.length;
	P = new double[Len];
	Q = new double[Len];

	System.arraycopy(wave, 0, P, 0, Len);
	for(int i = 0; i < Len; i++)
	    Q[i] = Math.pow(-1, i) * P[Len-i-1];
    }
    public static double getData(int num) {
	return Scl[num];
    }
    //
    public void calcWavelet(int[] data, int mm, int nb) {
	int len = mm;
	Scl = new double[len];
	S1 = new double[len];
	W1 = new double[len];

	for(int i = 0; i < len; i++) // int->double
	    Scl[i] = data[i];
	for(int j = 1; j < nb; j++) {
	    fwt1d(len);
	    len /= 2;
	    System.arraycopy(S1, 0, Scl, 0, len);
	    System.arraycopy(W1, 0, Scl, len, len);
	}
    }
    public void fwt1d(int len) {
	int ind, le2 = len/2;
	for (int i = 0; i < le2; i++) {
	    S1[i] = 0;
	    W1[i] = 0;
	    for(int j = 0; j < Len; j++) {
		ind = (j+2*i)%len;
		W1[i] += Q[j]*Scl[ind];
		S1[i] += P[j]*Scl[ind];
	    }
	}
    }
}