/* $Id: MemBurg.java,v 1.4 2008/01/19 05:54:07 mit Exp $ */
/* MemBurg.java v0.1 */

public class MemBurg {
    private final int Lmax = 1001; // ؤ饰

    private int Nmax; // ǡ
    private int Mmax; // ͽ¬ե륿
    private int NYQ;  // ʥȼȿ
    private double DT;  // 1.0/Splngf;
    private double DT2; // 2*DT;
    private double PD1; // 2*Math.PI*DT;
    private double PM;  // ͽ¬ե륿ʿѽ
    private double Xmax;
    private double[] b1;
    private double[] b2;
    private double[] g;   // ͽ¬ե륿
    private double[] c;   // ط
    private double[] fpe; // ͽ¬ʬ
    private double[] aic; // Ӿ
    private double[] e;

    public MemBurg() {}
    public void initMEM(int max) {
	Mmax = max;
	g = new double[Mmax+1];
	fpe = new double[Mmax+1];
	aic = new double[Mmax+1];
	c = new double[Lmax+1];
    }
    public void setNN(int nn, int splgf, int mmax) {
	NYQ = splgf/2;
	e = new double[NYQ+1];

	Nmax = nn;
	DT = 1.0/splgf;
	PD1 = 2*Math.PI;//*DT;
	DT2 = 2*DT;
 	b1 = new double[Nmax+1];
	b2 = new double[Nmax+1];

	initMEM(mmax);
    }
    public void calcMem(int sf, int[] dt) {
	read(sf, dt);
	burg();
	mem();
    }
    //
    public void read(int sf, int[] dt) { // averge
	double sum = 0;	//double smax = Short.MAX_VALUE/2;
	for (int i = 0; i < Nmax; i++)
	    sum += Math.pow(dt[i+sf], 2);
	PM = c[1] = sum/Nmax;

	b1[1] = dt[sf];
	for (int i = 2; i <= Nmax; i++)
	    b1[i] = b2[i-1] = dt[i-1+sf];
    }
    public void burg() {
	double stn, std, sum;
	double[] gg = new double[Mmax+1];

	for (int m = 1; m <= Mmax; m++) {
	    stn = std = 0;
	    for (int i = 1; i <= Nmax-m; i++) {
		stn += b1[i]*b2[i];
		std += Math.pow(b1[i], 2)+Math.pow(b2[i], 2);
	    }
	    g[m] = -2.0*stn/std;
	    PM *= 1.0-Math.pow(g[m], 2);

	    if (m != 1) {
		for (int k = 1; k <= m-1; k++)
		    g[k] = gg[k]+g[m]*gg[m-k];
	    }

	    for (int i = 1; i <= Nmax-m-1; i++) {
		b1[i] += g[m]*b2[i];
		b2[i] = b2[i+1]+g[m]*b1[i+1];
	    }
	    System.arraycopy(g, 1, gg, 1, m);

	    sum = 0;
	    for (int i = 1; i <= m; i++)
		sum -= c[m+1-i]*g[i];
	    c[m+1] = sum;

	    if (m != Nmax-1) {
		fpe[m] = (Nmax+m+1)/(Nmax-m-1)*PM;
		aic[m] = Nmax*Math.log(PM)+2.0*m;
	    }
	}
    }
    public void mem() {
	double f0 = PD1/(Nmax-1); // 1.0/((Nmax-1)*DT);
	double pd2 = DT2*PM;
	Complex c0 = new Complex(0.0, 1.0);
	Complex ci, cj, ex, sum, sum0 = new Complex(1.0, 0);

	Xmax = 0;
	for (int i = 1; i <= NYQ; i++) {
	    sum = sum0;
	    ci = c0.multiply(f0*(i-1)); // PD1*f0*(i-1));
	    for (int j = 1; j <= Mmax; j++) {
		cj = ci.multiply(j);
		ex = cj.exponent();
		sum = sum.add(ex.multiply(g[j]));
	    }
	    e[i] = pd2/Math.pow(sum.magnitude(), 2);

	    if (Xmax < e[i])
		Xmax = e[i];
	}

 	if (Mmax < Lmax) {
	    double sm;
	    for (int l = Mmax+1; l < Lmax; l++) {
		sm = 0;
		for (int i = 1; i <= Mmax; i++)
		    sm -= c[l+1-i]*g[i];
		c[l+1] = sm;
	    }
	}
    }
    //
    public double[] getData() {
	return e;
    }
    public double getData(int num) {
	return (num > NYQ) ? 0 : e[num]; //
    }
    public double getXmax() {
	return Xmax;
    }
    //
    public double[] getG() {
	return g;
    }
    public double getG(int num) {
	return g[num];
    }
    public double[] getC() {
	return c;
    }
    public double getC(int num) {
	return c[num];
    }
    public double[] getFPE() {
	return fpe;
    }
    public double getFPE(int num) {
	return fpe[num];
    }
    public double[] getAIC() {
	return aic;
    }
    public double getAIC(int num) {
	return aic[num];
    }
}